glibmm: Gio::ZlibCompressor Class Reference

glibmm 2.88.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::ZlibCompressor Class Reference

ZlibCompressor - Zlib compressor. More...

`#include <giomm/zlibcompressor.h>`

Inheritance diagram for Gio::ZlibCompressor:
[legend]

## Public Member Functions
| ZlibCompressor (ZlibCompressor && src) noexcept
ZlibCompressor & | operator= (ZlibCompressor && src) noexcept
| ~ZlibCompressor () noexcept override
GZlibCompressor * | gobj ()
| Provides access to the underlying C GObject.
const GZlibCompressor * | gobj () const
| Provides access to the underlying C GObject.
GZlibCompressor * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< FileInfo > | get_file_info ()
| Gets the Gio::ZlibCompressor::property_file_info() property.
Glib::RefPtr< const FileInfo > | get_file_info () const
| Gets the Gio::ZlibCompressor::property_file_info() property.
void | set_file_info (const Glib::RefPtr< FileInfo > & file_info)
| Sets the Gio::ZlibCompressor::property_file_info() property.
int | get_os () const
| Gets the Gio::ZlibCompressor::property_os() property.
void | set_os (int os) const
| Sets the Gio::ZlibCompressor::property_os() property.
Glib::PropertyProxy< Glib::RefPtr< FileInfo > > | property_file_info ()
| A Gio::FileInfo containing file information to put into the gzip header.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< FileInfo > > | property_file_info () const
| A Gio::FileInfo containing file information to put into the gzip header.
Glib::PropertyProxy_ReadOnly< ZlibCompressorFormat > | property_format () const
| The format of the compressed data.
Glib::PropertyProxy_ReadOnly< int > | property_level () const
| The level of compression from 0 (no compression) to 9 (most compression).
Glib::PropertyProxy< int > | property_os ()
| The OS code of the gzip header.
Glib::PropertyProxy_ReadOnly< int > | property_os () const
| The OS code of the gzip header.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data_with_c_callback (const Quark & key, void * data, GDestroyNotify notify)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::Converter
| Converter (Converter && src) noexcept
Converter & | operator= (Converter && src) noexcept
| ~Converter () noexcept override
GConverter * | gobj ()
| Provides access to the underlying C GObject.
const GConverter * | gobj () const
| Provides access to the underlying C GObject.
Result | convert (const void * inbuf, gsize inbuf_size, void * outbuf, gsize outbuf_size, Flags flags, gsize & bytes_read, gsize & bytes_written)
| This is the main operation used when converting data.
void | reset ()
| Resets all internal state in the converter, making it behave as if it was just created.
Glib::RefPtr< Glib::Bytes > | convert (const Glib::RefPtr< const Glib::Bytes > & bytes)
| Applies converter to the data in bytes.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< ZlibCompressor > | create (ZlibCompressorFormat format, int level)
| Creates a compressor.
Static Public Member Functions inherited from Gio::Converter
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| ZlibCompressor (ZlibCompressorFormat format, int level)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::Converter
| Converter ()
| You should derive from this class to use it.
virtual Result | convert_vfunc (const void * inbuf, gsize inbuf_size, void * outbuf, gsize outbuf_size, Flags flags, gsize & bytes_read, gsize & bytes_written)
virtual void | reset_vfunc ()

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::ZlibCompressor > | wrap (GZlibCompressor * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Symbols inherited from Gio::Converter
Glib::RefPtr< Gio::Converter > | wrap (GConverter * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gio::Converter
enum class | Result { Result::ERROR , Result::CONVERTED , Result::FINISHED , Result::FLUSHED }
| Results returned from g_converter_convert(). More...
enum class | Flags { Flags::NO_FLAGS = 0x0 , Flags::INPUT_AT_END = (1 << 0) , Flags::FLUSH = (1 << 1) }
| Flags used when calling a g_converter_convert(). More...

## Detailed Description

ZlibCompressor - Zlib compressor.

ZlibCompressor is an implementation of Converter that compresses data using zlib.

Since glibmm 2.34

## Constructor & Destructor Documentation

## ◆ ZlibCompressor() [1/2]

Gio::ZlibCompressor::ZlibCompressor | ( | ZlibCompressor && | src | ) |
| noexcept

## ◆ ~ZlibCompressor()

Gio::ZlibCompressor::~ZlibCompressor | ( |  | ) |
| overridenoexcept

## ◆ ZlibCompressor() [2/2]

Gio::ZlibCompressor::ZlibCompressor | ( | ZlibCompressorFormat | format,
|  | int | level )
| explicitprotected

## Member Function Documentation

## ◆ create()

Glib::RefPtr< ZlibCompressor > Gio::ZlibCompressor::create | ( | ZlibCompressorFormat | format,
|  | int | level )
| static

Creates a compressor.

Since glibmm 2.24

Parameters

  format | The format to use for the compressed data.
  level | Compression level (0-9), -1 for default.

Returns
  A new Gio::ZlibCompressor.

## ◆ get_file_info() [1/2]

Glib::RefPtr< FileInfo > Gio::ZlibCompressor::get_file_info | ( |  | ) |

Gets the Gio::ZlibCompressor::property_file_info() property.

Since glibmm 2.26

Returns
  File info for the gzip header, if set.

## ◆ get_file_info() [2/2]

Glib::RefPtr< const FileInfo > Gio::ZlibCompressor::get_file_info | ( |  | ) | const

Gets the Gio::ZlibCompressor::property_file_info() property.

Since glibmm 2.26

Returns
  File info for the gzip header, if set.

## ◆ get_os()

int Gio::ZlibCompressor::get_os | ( |  | ) | const

Gets the Gio::ZlibCompressor::property_os() property.

Since glibmm 2.86

Returns
  The previously set OS value, or -1 if unset.

## ◆ get_type()

GType Gio::ZlibCompressor::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GZlibCompressor * Gio::ZlibCompressor::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GZlibCompressor * Gio::ZlibCompressor::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GZlibCompressor * Gio::ZlibCompressor::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

ZlibCompressor & Gio::ZlibCompressor::operator= | ( | ZlibCompressor && | src | ) |
| noexcept

## ◆ property_file_info() [1/2]

Glib::PropertyProxy< Glib::RefPtr< FileInfo > > Gio::ZlibCompressor::property_file_info | ( |  | ) |

A Gio::FileInfo containing file information to put into the gzip header.

The file name and modification time from the file info will be used.

This will only be used if non-nullptr and Gio::ZlibCompressor::property_format() is Gio::ZlibCompressorFormat::GZIP.

Since glibmm 2.26

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_file_info() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< FileInfo > > Gio::ZlibCompressor::property_file_info | ( |  | ) | const

A Gio::FileInfo containing file information to put into the gzip header.

The file name and modification time from the file info will be used.

This will only be used if non-nullptr and Gio::ZlibCompressor::property_format() is Gio::ZlibCompressorFormat::GZIP.

Since glibmm 2.26

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_format()

Glib::PropertyProxy_ReadOnly< ZlibCompressorFormat > Gio::ZlibCompressor::property_format | ( |  | ) | const

The format of the compressed data.

Since glibmm 2.24

Default value: Gio::ZlibCompressorFormat::ZLIB

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_level()

Glib::PropertyProxy_ReadOnly< int > Gio::ZlibCompressor::property_level | ( |  | ) | const

The level of compression from 0 (no compression) to 9 (most compression).

-1 for the default level.

Since glibmm 2.24

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_os() [1/2]

Glib::PropertyProxy< int > Gio::ZlibCompressor::property_os | ( |  | ) |

The OS code of the gzip header.

This will be used if set to a non-negative value, and if Gio::ZlibCompressor::property_format() is Gio::ZlibCompressorFormat::GZIP, the compressor will set the OS code of the gzip header to this value.

If the value is unset, zlib will set the OS code depending on the platform. This may be undesirable when reproducible output is desired. In that case setting the OS code to 3 (for Unix) is recommended.

Since glibmm 2.86

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_os() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gio::ZlibCompressor::property_os | ( |  | ) | const

The OS code of the gzip header.

This will be used if set to a non-negative value, and if Gio::ZlibCompressor::property_format() is Gio::ZlibCompressorFormat::GZIP, the compressor will set the OS code of the gzip header to this value.

If the value is unset, zlib will set the OS code depending on the platform. This may be undesirable when reproducible output is desired. In that case setting the OS code to 3 (for Unix) is recommended.

Since glibmm 2.86

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_file_info()

void Gio::ZlibCompressor::set_file_info | ( | const Glib::RefPtr< FileInfo > & | file_info | ) |

Sets the Gio::ZlibCompressor::property_file_info() property.

Note
  it is an error to call this function while a compression is in progress; it may only be called immediately after creation of compressor, or after resetting it with Gio::Converter::reset().

Since glibmm 2.26

Parameters

  file_info | File info for the gzip header.

## ◆ set_os()

void Gio::ZlibCompressor::set_os | ( | int | os | ) | const

Sets the Gio::ZlibCompressor::property_os() property.

Note
  it is an error to call this function while a compression is in progress; it may only be called immediately after creation of compressor, or after resetting it with Gio::Converter::reset().

Since glibmm 2.86

Parameters

  os | The OS code to use, or -1 to unset.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::ZlibCompressor > wrap | ( | GZlibCompressor * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.